CTM_MAIL(1)

NAME
ctm_smail, ctm_rmail - send and receive ctm deltas via mail

SYNOPSIS
ctm_smail [-l log] [-m maxmsgsize] [-c maxctmsize] ctm-delta mail-alias
ctm_rmail [-Df] [-l log] [-p piecedir] [-d deltadir] [-b basedir] [file ...]

DESCRIPTION
In conjuction with the ctm(1) command, ctm_smail and ctm_rmail are used to distribute changes to a source tree via email. ctm_smail is given a compressed ctm delta, and a mailing list to send it to. It splits the delta into manageable pieces, encodes them as mail messages and sends them to the mailing list. Each recipient uses ctm_rmail (either manually or automatically) to decode and reassemble the delta, and optionally call ctm to apply it to the source tree. At the moment, only two source trees are distributed, and both by the same site. These are the FreeBSD-current source and CVS trees, distributed by ref.tfs.com.

Command line arguments for ctm_smail:

-l log
    Instead of appearing on stderr, error diagnostics and informational messages (other than command line errors) are time stamped and written to the file log.

-m maxmsgsize
    Limit the maximum size mail message that ctm_smail is allowed to send. It is approximate since mail headers and other niceties are not counted in this limit. If not specified, it will default to 64000 bytes, leaving room for 1535 bytes of headers before the rumoured 64k mail limit.

-c maxctmsize
    Limit the maximum size delta that will be sent. Deltas bigger that this limit will cause an apology mail message to be sent to the mailing list. This is to prevent massive changes overwhelming users' mail boxes. Note that this is the size before encoding. Encoding causes a 4/3 size increase before mail headers are added. If not specified, there is no limit.

ctm-delta is the delta to be sent, and mail-alias is the mailing list to send the delta to. The mail messages are sent using sendmail(8).

Command line arguments for ctm_rmail:

-l log
    Instead of appearing on stderr, error diagnostics and informational messages (other than command line errors) are time stamped and written to the file log.

-p piecedir
    Collect pieces of deltas in this directory. Each piece corresponds to a single mail message. Pieces are removed when complete deltas are built. If this flag is not given, no input files will be read, but completed deltas may still be applied with ctm if the -b flag is given.

-d deltadir
    Collect completed deltas in this directory. Deltas are built from one or more pieces when all pieces are present.

-b basedir
    Apply any completed deltas to this source tree. If this flag is not given, deltas will be stored, but not applied. The user may then apply the deltas manually, or by using ctm_rmail without the -p flag. Deltas will not be applied if they do not match the .ctm_status file in basedir (or if .ctm_status does not exist).

-D  Delete deltas after successful application by ctm. It is probably a good idea to avoid this flag (and keep all the deltas) as one of the possible future enhancements to ctm is the ability to recover small groups of files from a full set of deltas.

-f  Fork and execute in the background while applying deltas with ctm. This is useful when automatically invoking ctm_rmail from sendmail because ctm can take a very long time to complete, causing other people's mail to be delayed, and can in theory cause spurious mail retransmission due to the remote sendmail timing out, or even termination of ctm_rmail by mail filters such as MH's slocal. Don't worry about zillions of background ctm processes loading your machine, since locking is used to prevent more than one ctm invocation at a time.

The file arguments (or stdin, if there are none) are scanned for delta pieces. Multiple delta pieces can be read from a single file, so an entire maildrop can be scanned and processed with a single command.

It is safe to invoke ctm_rmail multiple times concurrently (with different input files), as might happen when sendmail is delivering mail asynchronously. This is because locking is used to keep things orderly.

FILE FORMAT
Following are the important parts of an actual (very small) delta piece:

    From: owner-src-cur
    To: src-cur
    Subject: ctm-mail src-cur.0003.gz 1/4
    CTM_MAIL BEGIN src-cur.0003.gz 1 4
    H4sIAAAAAAACA3VU72/bNhD9bP0VByQoEiyRSZEUSQP9kKTeYCR2gDTdsGFAwB/HRogtG5K8NCj6
    v4+UZSdtUQh6Rz0eee/xaF/dzx8up3/MFlDkBNrGnbttAwyo1pxoRgoiBNX/QJ5d3c9/X8DcPGGo
    lggkPiXngE4W1gUjKPJCYyk5MZRbIqmNW/ASglIFcdwIzTUxaAqhnCPcBqloKEkJVNDMF0Azk+Bo
    dDzzk0Ods/+A5gXv9YyJHjMCtJwQNeESNma7hOmXDRxn
    CTM_MAIL END 61065

The subject of the message always begins with “ctm-mail” followed by the name of the delta, which piece this is, and how many total pieces there are. The data is bracketed by “CTM_MAIL BEGIN” and “CTM_MAIL END” lines, duplicating the information in the subject line, plus a simple checksum.

If the delta exceeds maxctmsize, then a message like this will be received instead:

    From: owner-src-cur
    To: src-cur
    Subject: ctm-notice src-cur.0999.gz
    src-cur.0999.gz is 792843 bytes.  The limit is 300000 bytes.
    You can retrieve this delta via ftpmail, or your good mate at the university.

You are then on your own!

EXAMPLES
To send delta 32 of src-cur to a group of wonderful code hackers known to sendmail as src-guys, limiting the mail size to roughly 60000 bytes, you could use:

    ctm_smail -m 60000 /wherever/it/is/src-cur.0032.gz src-guys

To decode every ctm-mail message in your mailbox, assemble them into complete deltas, then apply any deltas built or lying around, you could use:

    ctm_rmail -p ~/pieces -d ~/deltas -b /usr/ctm-src-cur $MAIL

(Note that no messages are deleted by ctm_rmail. Any mail reader could be used for that purpose.)

To create a mail alias called receiver-dude that will automatically decode and assemble deltas, but not apply them, you could put the following lines in your /etc/aliases file (assuming the /ctm/tmp and /ctm/deltas directories and /ctm/log file are writable by user daemon or group wheel):

    receiver-dude: "|ctm_rmail -p /ctm/tmp -d /ctm/deltas -l /ctm/log"
    owner-receiver-dude: real_dude@wherever.you.like

The second line will catch failures and drop them into your regular mailbox, or wherever else you like.

To apply all the deltas collected, and delete those applied, you could use:

    ctm_rmail -D -d /ctm/deltas -b /ctm/src-cur -l /ctm/apply.log

SECURITY
If you automatically take your mail and pass it to a file tree patcher, you might think you are handing the keys to your system to the hackers! Happily, the window for mischief is quite small. ctm_rmail is careful to write only to the directories given to it (by not believing any “/” characters in the delta name), and the latest ctm disallows absolute pathnames and “..” in files it manipulates, so the worst you could lose are a few source tree files (recoverable from your deltas). Since ctm requires that a md5 checksum match before it touches a file, only fellow source recipients would be able to generate a fake delta, and they're such nice folk that they wouldn't even think of it! :-)

Even this possibility could be removed by using cryptographic signatures. A possible future enhancement would be to use PGP to provide a secure wrapper.

ENVIRONMENT
If deltas are to be applied then ctm(1) and gunzip(1) must be in your PATH.

FILES

PIECEDIR/*
    Pieces of deltas waiting for the rest.

DELTADIR/*
    Completed deltas.

BASEDIR/.ctm_status
    File containing name and number of the next delta to be applied to this source tree.

DIAGNOSTICS
ctm_smail and ctm_rmail return exit status 0 for success, and 1 for various failures. ctm_rmail is expected to be called from a mail transfer program, and thus signals failure only when the input mail message should be bounced (preferably into your regular maildrop, not back to the sender). In short, failure to apply a completed delta with ctm is not considered an error important enough to bounce the mail, and ctm_rmail returns an exit status of 0.

In normal operation, ctm_smail will report messages like:

    ctm_smail: src-cur.0250.gz 1/2 sent to src-guys

ctm_rmail will report messages like:

    ctm_rmail: src-cur.0250.gz 1/2 stored
    ctm_rmail: src-cur.0250.gz 2/2 stored
    ctm_rmail: src-cur.0250.gz complete

If any of the input files do not contain a valid delta piece, ctm_rmail will report:

    ctm_rmail: message contains no delta

and return an exit status of 1. You can use this to redirect wayward messages back into your real mailbox if your mail filter goes wonky.

These messages go to stderr or to the log file. Messages from ctm turn up here too. Error messages should be self explanatory.

SEE ALSO
ctm(1) (coming soon)

AUTHOR
Stephen McKay <syssgm@devetir.qld.gov.au>